(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of ocamlprint_xmlc.bin generated code *)

let print_xml_index ppf = function
  | u_i -> Upervasives_print_xml.print_xml_index ppf u_i
;;

let print_xml_offset ppf = function
  | u_t -> Unatural_print_xml.print_xml_t ppf u_t

and print_xml_length ppf = function
  | u_l -> Upervasives_print_xml.print_xml_length ppf u_l
;;

let print_xml_range ppf = function
  | { Usubarray_types.offset = o; Usubarray_types.length = l; } ->
    Format.fprintf ppf "%,@[<1>{@,"; print_xml_offset ppf o;
    Format.fprintf ppf "%,;"; print_xml_length ppf l;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_indices ppf = function
  | Usubarray_types.Range r ->
    Format.fprintf ppf "@[<1>%s@," "<Range>"; print_xml_range ppf r;
    Format.fprintf ppf "%,</Range>"; Format.fprintf ppf "%,@]"
  | Usubarray_types.Indices i_a ->
    Format.fprintf ppf "@[<1>%s@," "<Indices>";
    Lib_print_xml.print_xml_Array print_xml_index ppf i_a;
    Format.fprintf ppf "%,</Indices>"; Format.fprintf ppf "%,@]"
;;

let print_xml_t px_a ppf = function
  | { Usubarray_types.support = a_a; Usubarray_types.indices = i; } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Lib_print_xml.print_xml_Array px_a ppf a_a; Format.fprintf ppf "%,;";
    print_xml_indices ppf i; Format.fprintf ppf "%,;";
    Format.fprintf ppf "%,@,}@]"
;;

(* End of ocamlprint_xmlc.bin generated code *)
