(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of ocamlprintc.bin generated code *)

let print_index pp_a ppf = function
  | a_u_t -> Uindex_print.print_t pp_a ppf a_u_t
;;

let print_indices _pp_a ppf = function | a -> Lib_print.print_abstract ppf a
;;

let print_elements pp_a ppf = function
  | a_a -> Lib_print.print_Array pp_a ppf a_a
;;

let print_t pp_a ppf = function
  | {
      Uuniverse.indices = a_i;
      Uuniverse.elements = a_e;
      Uuniverse.cardinal = u_t;
    } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>indices =@ ";
    print_indices pp_a ppf a_i; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>elements =@ "; print_elements pp_a ppf a_e;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@[<1>cardinal =@ ";
    Unatural_print.print_t ppf u_t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@,}@]"
;;

(* End of ocamlprintc.bin generated code *)
