(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex_set.mli,v 1.1 2013/06/04 17:11:41 fclement Exp $ *)

(** {3 The module defining sets of indices} *)

type 'a multi_d = 'a Uindex_set_types.multi_d;;

(** {6 Mono-dimensional range} *)

type uni_range = Uindex_set_types.uni_range;;

val empty_uni_range : uni_range;;
val is_empty_uni_range : uni_range -> bool;;

val uni_range : Unatural.t -> Unatural.t -> uni_range;;

(** {6 Range} *)

type range = uni_range multi_d;;

val empty_range : range;;
val is_empty_range : range -> bool;;

(** {6 Index set} *)

type index = int multi_d;;

type index_set = Uindex_set_types.index_set;;
type t = index_set;;

val empty_index_set : index_set;;
val is_empty_index_set : index_set -> bool;;

val is_range : range -> index_set;;
val is_array : index array -> index_set;;
val is_union : index_set -> index_set -> index_set;;
